## mlpack 4.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)
project(mlpack C CXX)

include(CMake/CheckHash.cmake)
include(CMake/ConfigureCrossCompile.cmake)
include(CMake/CheckAtomic.cmake)
include(CMake/mlpack.cmake)

# First, define all the compilation options.
option(DEBUG "Compile with debugging information." OFF)
option(PROFILE "Compile with profiling information." OFF)
option(ARMA_EXTRA_DEBUG "Compile with extra Armadillo debugging symbols." OFF)
option(TEST_VERBOSE "Run test cases with verbose output." OFF)
option(BUILD_TESTS "Build tests. (Note: time consuming!)" OFF)
option(BUILD_CLI_EXECUTABLES "Build command-line executables." ON)
option(DOWNLOAD_DEPENDENCIES "Automatically download dependencies if not available." OFF)
option(BUILD_GO_SHLIB "Build Go shared library." OFF)
option(USE_PRECOMPILED_HEADERS "Use precompiled headers for mlpack_test build." ON)
option(USE_SYSTEM_STB "Use system STB instead of version bundled with mlpack." OFF)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

if (PROFILE)
  message(WARNING "The PROFILE option is deprecated and will be removed in mlpack 5.0.0; specify -DCMAKE_CXX_FLAGS=\"-pg\" instead!")
endif()

# Consider using ccache
find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

# If BUILD_SHARED_LIBS is OFF then the mlpack library will be built statically.
# In addition, all mlpack CLI bindings will be linked statically as well.
if (WIN32)
  option(BUILD_SHARED_LIBS
      "Compile shared objects for tests and bindings (if OFF, static libraries and binaries are compiled)." OFF)

  set(DLL_COPY_DIRS "" CACHE STRING "List of directories (separated by ';') containing DLLs to copy for runtime.")
  set(DLL_COPY_LIBS "" CACHE STRING "List of DLLs (separated by ';') that should be copied for runtime.")
elseif(CMAKE_CROSSCOMPILING)
  option(BUILD_SHARED_LIBS
      "Compile shared libraries (if OFF, static libraries and binaries are compiled)." OFF)
else()
  option(BUILD_SHARED_LIBS
      "Compile shared objects for tests and bindings (if OFF, static libraries and binaries are compiled)." ON)
endif()

# Support preference of static libs by adjusting CMAKE_FIND_LIBRARY_SUFFIXES.
if (NOT BUILD_SHARED_LIBS)
  if(WIN32)
    list(INSERT CMAKE_FIND_LIBRARY_SUFFIXES 0 .lib .a)
  else()
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
  endif()
endif()

# Detect whether the user passed BUILD_PYTHON_BINDINGS in order to determine if
# we should fail if Python isn't found.
if (BUILD_PYTHON_BINDINGS)
  set(FORCE_BUILD_PYTHON_BINDINGS ON)
else()
  set(FORCE_BUILD_PYTHON_BINDINGS OFF)
endif()
option(BUILD_PYTHON_BINDINGS "Build Python bindings." OFF)

# Detect whether the user passed BUILD_JULIA_BINDINGS in order to determine if
# we should fail if Julia isn't found.
if (BUILD_JULIA_BINDINGS)
  set(FORCE_BUILD_JULIA_BINDINGS ON)
else()
  set(FORCE_BUILD_JULIA_BINDINGS OFF)
endif()
option(BUILD_JULIA_BINDINGS "Build Julia bindings." OFF)

# Detect whether the user passed BUILD_GO_BINDINGS in order to determine if
# we should fail if Go isn't found.
if (BUILD_GO_BINDINGS)
  set(FORCE_BUILD_GO_BINDINGS ON)
else()
  set(FORCE_BUILD_GO_BINDINGS OFF)
endif()
option(BUILD_GO_BINDINGS "Build Go bindings." OFF)

# If building Go bindings then build go shared libraries.
if (BUILD_GO_BINDINGS)
  set(BUILD_GO_SHLIB ON)
endif()

# Detect whether the user passed BUILD_R_BINDINGS in order to determine if
# we should fail if R isn't found.
if (BUILD_R_BINDINGS)
  set(FORCE_BUILD_R_BINDINGS ON)
else()
  set(FORCE_BUILD_R_BINDINGS OFF)
endif()
option(BUILD_R_BINDINGS "Build R bindings." OFF)
# Build Markdown bindings for documentation.  This is used as part of website
# generation.
option(BUILD_MARKDOWN_BINDINGS "Build Markdown bindings for website documentation." OFF)
option(USE_OPENMP "If available, use OpenMP for parallelization." ON)
enable_testing()

# Ensure that GCC is new enough, if the compiler is GCC.
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8)
  message(FATAL_ERROR "GCC version (${CMAKE_CXX_COMPILER_VERSION}) is too old! 8.x or newer is required.")
endif ()

# Include modules in the CMake directory.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

# If we are not using Visual Studio, use the GNU install directories module.
# Otherwise set the values manually.
if (NOT MSVC)
  include(GNUInstallDirs)
else ()
  set(CMAKE_INSTALL_BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib)
  set(CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_PREFIX}/man)
  set(CMAKE_INSTALL_DOCDIR ${CMAKE_INSTALL_PREFIX}/share/doc/mlpack)
  set(CMAKE_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include)
endif ()

# This is as of yet unused.
# option(PGO "Use profile-guided optimization if not a debug build" ON)

# Set the CFLAGS and CXXFLAGS depending on the options the user specified.
# Only GCC-like compilers support -Wextra, and other compilers give tons of
# output for -Wall, so only -Wall and -Wextra on GCC.
if (CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  # Ensure that we can't compile with clang 3.4, since this causes strange
  # issues.
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5)
    message(FATAL_ERROR "mlpack does not build correctly with clang < 3.5.  "
        "Please upgrade your compiler and reconfigure mlpack.")
  endif ()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -ftemplate-depth=1000")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")

  # To remove unused functions warnings as well as missing-field-inits (from STB)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function -Wno-missing-field-initializers")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
endif()

# Check if atomics need -latomic linking.
#include(CheckAtomic)
if (NOT HAVE_CXX_ATOMICS_WITHOUT_LIB AND
    NOT HAVE_CXX_ATOMICS64_WITHOUT_LIB AND
    NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -latomic")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -latomic")
endif ()

# If we are using MSVC, we need /bigobj.
if (MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /Zc:__cplusplus")
endif ()

# If we are using MINGW, we need sections and big-obj, otherwise we create too
# many sections.
if (CMAKE_COMPILER_IS_GNUCC AND WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wa,-mbig-obj")
endif()

# If using clang, we have to link against libc++ depending on the
# OS (at least on some systems). Further, gcc sometimes optimizes calls to
# math.h functions, making -lm unnecessary with gcc, but it may still be
# necessary with clang.
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if (APPLE)
    # Detect OS X version. Use '/usr/bin/sw_vers -productVersion' to
    # extract V from '10.V.x'.
    exec_program(/usr/bin/sw_vers ARGS
        -productVersion OUTPUT_VARIABLE MACOSX_VERSION_RAW)
    string(REGEX REPLACE
        "([0-9]+)(\\.([0-9]+).*)*" "\\1"
        MACOSX_MAJOR_VERSION
        "${MACOSX_VERSION_RAW}")

    string(REGEX REPLACE
        "([0-9]+)(\\.([0-9]+).*)*" "\\3"
        MACOSX_MINOR_VERSION
        "${MACOSX_VERSION_RAW}")
  endif()

  # Link everything with -lm.
  set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} "m")
  # Use -pthread, but not on OS X.
  if (NOT APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif ()
endif()

# Debugging CFLAGS.  Turn optimizations off; turn debugging symbols on.
set (BFD_DL_AVAILABLE "NO")
if (DEBUG)
  message(WARNING "The DEBUG option is deprecated and will be removed in mlpack 5.0.0; specify CMAKE_BUILD_TYPE as \"Debug\" instead!")
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug" OR DEBUG)
  if (NOT MSVC)
    add_definitions(-DDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-backtrace-limit=0")
  endif()

  # mlpack uses it's own mlpack::backtrace class based on Binary File Descriptor
  # <bfd.h> and linux Dynamic Loader <libdl.h> and more portable version in
  # future.  However, if we are cross-compiling, we cannot run the CMake tests
  # for LibDL and BFD.
  if (CMAKE_SYSTEM_NAME STREQUAL "Linux" AND NOT CMAKE_CROSSCOMPILING)
    find_package(Bfd)
    find_package(LibDL)
    if (LIBBFD_FOUND AND LIBDL_FOUND)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -rdynamic")
      set(MLPACK_INCLUDE_DIRS ${MLPACK_INCLUDE_DIRS} ${LIBBFD_INCLUDE_DIRS}
          ${LIBDL_INCLUDE_DIRS})
      set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${LIBBFD_LIBRARIES}
          ${LIBDL_LIBRARIES})
      set(BFD_DL_AVAILABLE "YES")
    else()
      message(WARNING "No libBFD and/or libDL has been found!")
    endif()
  endif()
endif()

# Profiling CFLAGS.  Turn profiling information on.
if (CMAKE_COMPILER_IS_GNUCC AND PROFILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
endif()

# If the user asked for extra Armadillo debugging output, turn that on.
if (ARMA_EXTRA_DEBUG)
  add_definitions(-DARMA_EXTRA_DEBUG)
endif()

if (NOT USE_OPENMP)
  set(MLPACK_DISABLE_OPENMP ON)
endif()

if (USE_SYSTEM_STB)
  set(MLPACK_USE_SYSTEM_STB ON)
endif ()

set(MLPACK_DONT_FIND_MLPACK 1)
if (CMAKE_CROSSCOMPILING OR DOWNLOAD_DEPENDENCIES)
  fetch_mlpack(ON)
else()
  find_mlpack()
endif()
unset(MLPACK_DONT_FIND_MLPACK)

# Include directories for the previous dependencies.
set(MLPACK_INCLUDE_DIRS ${MLPACK_INCLUDE_DIRS} ${ARMADILLO_INCLUDE_DIRS})
set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${ARMADILLO_LIBRARIES})

if (USE_SYSTEM_STB)
  # Make sure that we can link STB in multiple translation units.
  include(CMake/TestStaticSTB.cmake)
  if (NOT CMAKE_HAS_WORKING_STATIC_STB)
    message(FATAL_ERROR "STB implementations's static mode cannot link across "
        "multiple translation units!  Try upgrading your STB implementation, "
        "or using the auto-downloader (set DOWNLOAD_DEPENDENCIES=ON in the "
        "CMake configuration command.")
  endif()
endif()

include_directories(BEFORE ${MLPACK_INCLUDE_DIRS})
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}/src/)

# On Windows, things end up under Debug/ or Release/.
if (WIN32)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

  # Copy all necessary DLLs for runtime to the build directory.
  # This is a little hackish, but I can't figure out clear ways to make CMake
  # consistently link everything 100% statically across platforms or set the
  # runtime path right always, so this is the best I know how to do for now.
  foreach(dir ${DLL_COPY_DIRS})
    file(GLOB dir_dll_list "${dir}/*.dll")
    file(COPY ${dir_dll_list} DESTINATION ${CMAKE_BINARY_DIR}/Release/)
    file(COPY ${dir_dll_list} DESTINATION ${CMAKE_BINARY_DIR}/Debug/)
  endforeach ()

  foreach(file ${DLL_COPY_LIBS})
    file(COPY ${file} DESTINATION ${CMAKE_BINARY_DIR}/Release/)
    file(COPY ${file} DESTINATION ${CMAKE_BINARY_DIR}/Debug/)
  endforeach()
else ()
  # If not on Windows, put them under more standard UNIX-like places.  This is
  # necessary, otherwise they would all end up in
  # ${CMAKE_BINARY_DIR}/src/mlpack/methods/... or somewhere else random like
  # that.
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib/)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib/)
endif ()

# Make a target to generate the man page documentation, but only if we are on a
# UNIX-like system.
if (BUILD_CLI_EXECUTABLES AND UNIX)
  find_program(TXT2MAN txt2man)

  # It's not a requirement that we make man pages.
  if (NOT TXT2MAN)
    message(WARNING "txt2man not found; man pages will not be generated.")
  else ()
    # We have the tools.  We can make them.
    add_custom_target(man ALL
        ${CMAKE_CURRENT_SOURCE_DIR}/CMake/allexec2man.sh

=== DESCRIPTION ===
Package: mlpack
Title: 'Rcpp' Integration for the 'mlpack' Library
Version: 4.7.0
Date: 2026-02-01
Authors@R: c(
    person("Yashwant", "Singh Parihar", email = "yashwantsingh.sngh@gmail.com", role = c("aut", "ctb", "cph")),
    person("Ryan", "Curtin", email = "ryan@ratml.org", role = c("aut", "ctb", "cph", "cre")),
    person("Dirk", "Eddelbuettel", email = "edd@debian.org", role = c("aut", "ctb", "cph")),
    person("James", "Balamuta", email = "james.balamuta@gmail.com", role = c("aut", "ctb", "cph")),
    person("Bill", "March", email = "march@gatech.edu", role = c("ctb", "cph")),
    person("Dongryeol", "Lee", email = "dongryel@cc.gatech.edu", role = c("ctb", "cph")),
    person("Nishant", "Mehta", email = "niche@cc.gatech.edu", role = c("ctb", "cph")),
    person("Parikshit", "Ram", email = "p.ram@gatech.edu", role = c("ctb", "cph")),
    person("James", "Cline", email = "james.cline@gatech.edu", role = c("ctb", "cph")),
    person("Sterling", "Peet", email = "sterling.peet@gatech.edu", role = c("ctb", "cph")),
    person("Matthew", "Amidon", email = "mamidon@gatech.edu", role = c("ctb", "cph")),
    person("Neil", "Slagle", email = "npslagle@gmail.com", role = c("ctb", "cph")),
    person("Ajinkya", "Kale", email = "kaleajinkya@gmail.com", role = c("ctb", "cph")),
    person("Vlad", "Grantcharov", email = "vlad321@gatech.edu", role = c("ctb", "cph")),
    person("Noah", "Kauffman", email = "notoriousnoah@gmail.com", role = c("ctb", "cph")),
    person("Rajendran", "Mohan", email = "rmohan88@gatech.edu", role = c("ctb", "cph")),
    person("Trironk", "Kiatkungwanglai", email = "trironk@gmail.com", role = c("ctb", "cph")),
    person("Patrick", "Mason", email = "patrick.s.mason@gmail.com", role = c("ctb", "cph")),
    person("Marcus", "Edel", email = "marcus.edel@fu-berlin.de", role = c("ctb", "cph")),
    person("Mudit", "Raj Gupta", email = "mudit.raaj.gupta@gmail.com", role = c("ctb", "cph")),
    person("Sumedh", "Ghaisas", email = "sumedhghaisas@gmail.com", role = c("ctb", "cph")),
    person("Michael", "Fox", email = "michaelfox99@gmail.com", role = c("ctb", "cph")),
    person("Siddharth", "Agrawal", email = "siddharth.950@gmail.com", role = c("ctb", "cph")),
    person("Saheb", "Motiani", email = "saheb210692@gmail.com", role = c("ctb", "cph")),
    person("Yash", "Vadalia", email = "yashdv@gmail.com", role = c("ctb", "cph")),
    person("Abhishek", "Laddha", email = "laddhaabhishek11@gmail.com", role = c("ctb", "cph")),
    person("Vahab", "Akbarzadeh", email = "v.akbarzadeh@gmail.com", role = c("ctb", "cph")),
    person("Andrew", "Wells", email = "andrewmw94@gmail.com", role = c("ctb", "cph")),
    person("Zhihao", "Lou", email = "lzh1984@gmail.com", role = c("ctb", "cph")),
    person("Udit", "Saxena", email = "saxenda.udit@gmail.com", role = c("ctb", "cph")),
    person("Stephen", "Tu", email = "tu.stephenl@gmail.com", role = c("ctb", "cph")),
    person("Jaskaran", "Singh", email = "jaskaranvirdi@ymail.com", role = c("ctb", "cph")),
    person("Hritik", "Jain", email = "hritik.jain.cse13@itbhu.ac.in", role = c("ctb", "cph")),
    person("Vladimir", "Glazachev", email = "glazachev.vladimir@gmail.com", role = c("ctb", "cph")),
    person("QiaoAn", "Chen", email = "kazenoyumechen@gmail.com", role = c("ctb", "cph")),
    person("Janzen", "Brewer", email = "jahabrewer@gmail.com", role = c("ctb", "cph")),
    person("Trung", "Dinh", email = "dinhanhtrung@gmail.com", role = c("ctb", "cph")),
    person("Tham", "Ngap Wei", email = "thamngapwei@gmail.com", role = c("ctb", "cph")),
    person("Grzegorz", "Krajewski", email = "krajekg@gmail.com", role = c("ctb", "cph")),
    person("Joseph", "Mariadassou", email = "joe.mariadassou@gmail.com", role = c("ctb", "cph")),
    person("Pavel", "Zhigulin", email = "pashaworking@gmail.com", role = c("ctb", "cph")),
    person("Andy", "Fang", email = "AndyFang.DZ@gmail.com", role = c("ctb", "cph")),
    person("Barak", "Pearlmutter", email = "barak+git@pearlmutter.net", role = c("ctb", "cph")),
    person("Ivari", "Horm", email = "ivari@risk.ee", role = c("ctb", "cph")),
    person("Dhawal", "Arora", email = "d.p.arora1@gmail.com", role = c("ctb", "cph")),
    person("Alexander", "Leinoff", email = "alexander-leinoff@uiowa.edu", role = c("ctb", "cph")),
    person("Palash", "Ahuja", email = "abhor902@gmail.com", role = c("ctb", "cph")),
    person("Yannis", "Mentekidis", email = "mentekid@gmail.com", role = c("ctb", "cph")),
    person("Ranjan", "Mondal", email = "ranjan.rev@gmail.com", role = c("ctb", "cph")),
    person("Mikhail", "Lozhnikov", email = "lozhnikovma@gmail.com", role = c("ctb", "cph")),
    person("Marcos", "Pividori", email = "marcos.pividori@gmail.com", role = c("ctb", "cph")),
    person("Keon", "Kim", email = "kwk236@gmail.com", role = c("ctb", "cph")),
    person("Nilay", "Jain", email = "nilayjain13@gmail.com", role = c("ctb", "cph")),
    person("Peter", "Lehner", email = "peter.lehner@dlr.de", role = c("ctb", "cph")),
    person("Anuraj", "Kanodia", email = "akanuraj200@gmail.com", role = c("ctb", "cph")),
    person("Ivan", "Georgiev", email = "ivan@jonan.info", role = c("ctb", "cph")),
    person("Shikhar", "Bhardwaj", email = "shikharbhardwaj68@gmail.com", role = c("ctb", "cph")),
    person("Yashu", "Seth", email = "yashuseth2503@gmail.com", role = c("ctb", "cph")),
    person("Mike", "Izbicki", email = "mike@izbicki.me", role = c("ctb", "cph")),
    person("Sudhanshu", "Ranjan", email = "sranjan.sud@gmail.com", role = c("ctb", "cph")),
    person("Piyush", "Jaiswal", email = "piyush.jaiswal@st.niituniversity.in", role = c("ctb", "cph")),
    person("Dinesh", "Raj", email = "dinu.iota@gmail.com", role = c("ctb", "cph")),
    person("Vivek", "Pal", email = "vivekpal.dtu@gmail.com", role = c("ctb", "cph")),
    person("Prasanna", "Patil", email = "prasannapatil08@gmail.com", role = c("ctb", "cph")),
    person("Lakshya", "Agrawal", email = "zeeshan.lakshya@gmail.com", role = c("ctb", "cph")),
    person("Praveen", "Ch", email = "chvsp972911@gmail.com", role = c("ctb", "cph")),
    person("Kirill", "Mishchenko", email = "ki.mishchenko@gmail.com", role = c("ctb", "cph")),
    person("Abhinav", "Moudgil", email = "abhinavmoudgil95@gmail.com", role = c("ctb", "cph")),
    person("Thyrix", "Yang", email = "thyrixyang@gmail.com", role = c("ctb", "cph")),
    person("Sagar", "B Hathwar", email = "sagarbhathwar@gmail.com", role = c("ctb", "cph")),
    person("Nishanth", "Hegde", email = "hegde.nishanth@gmail.com", role = c("ctb", "cph")),
    person("Parminder", "Singh", email = "parmsingh101@gmail.com", role = c("ctb", "cph")),
    person("CodeAi", "", email = "benjamin.bales@assrc.us", role = c("ctb", "cph")),
    person("Franciszek", "Stokowacki", email = "franek.stokowacki@gmail.com", role = c("ctb", "cph")),
    person("Samikshya", "Chand", email = "samikshya289@gmail.com", role = c("ctb", "cph")),
    person("N", "Rajiv Vaidyanathan", email = "rajivvaidyanathan4@gmail.com", role = c("ctb", "cph")),
    person("Kartik", "Nighania", email = "kartiknighania@gmail.com", role = c("ctb", "cph")),
    person("Eugene", "Freyman", email = "evg.freyman@gmail.com", role = c("ctb", "cph")),
    person("Manish", "Kumar", email = "manish887kr@gmail.com", role = c("ctb", "cph")),
    person("Haritha", "Sreedharan Nair", email = "haritha1313@gmail.com", role = c("ctb", "cph")),
    person("Sourabh", "Varshney", email = "sourabhvarshney111@gmail.com", role = c("ctb", "cph")),
    person("Projyal", "Dev", email = "projyal@gmail.com", role = c("ctb", "cph")),
    person("Nikhil", "Goel", email = "nikhilgoel199797@gmail.com", role = c("ctb", "cph")),
    person("Shikhar", "Jaiswal", email = "jaiswalshikhar87@gmail.com", role = c("ctb", "cph")),
    person("B", "Kartheek Reddy", email = "bkartheekreddy@gmail.com", role = c("ctb", "cph")),
    person("Atharva", "Khandait", email = "akhandait45@gmail.com", role = c("ctb", "cph")),
    person("Wenhao", "Huang", email = "wenhao.huang.work@gmail.com", role = c("ctb", "cph")),
    person("Roberto", "Hueso", email = "robertohueso96@gmail.com", role = c("ctb", "cph")),
    person("Prabhat", "Sharma", email = "prabhatsharma7298@gmail.com", role = c("ctb", "cph")),
    person("Tan", "Jun An", email = "yamidarkxxx@gmail.com", role = c("ctb", "cph")),
    person("Moksh", "Jain", email = "mokshjn00@gmail.com", role = c("ctb", "cph")),
    person("Manthan-R-Sheth", "", email = "manthanrsheth96@gmail.com", role = c("ctb", "cph")),
    person("Namrata", "Mukhija", email = "namratamukhija@gmail.com", role = c("ctb", "cph")),
    person("Conrad", "Sanderson", role = c("ctb", "cph")),
    person("Thanasis", "Mattas", email = "mattasa@auth.gr", role = c("ctb", "cph")),
    person("Shashank", "Shekhar", email = "contactshashankshekhar@gmail.com", role = c("ctb", "cph")),
    person("Yasmine", "Dumouchel", email = "yasmine.dumouchel@gmail.com", role = c("ctb", "cph")),
    person("German", "Lancioni", role = c("ctb", "cph")),
    person("Arash", "Abghari", email = "arash.abghari@gmail.com", role = c("ctb", "cph")),
    person("Ayush", "Chamoli", role = c("ctb", "cph")),
    person("Tommi", "Laivamaa", email = "tommi.laivamaa@protonmail.com", role = c("ctb", "cph")),
    person("Kim", "SangYeon", email = "sy0814k@gmail.com", role = c("ctb", "cph")),
    person("Niteya", "Shah", email = "niteya.56@gmail.com", role = c("ctb", "cph")),
    person("Toshal", "Agrawal", email = "tagrawal1339@gmail.com", role = c("ctb", "cph")),
    person("Dan", "Timson", role = c("ctb", "cph")),
    person("Miguel", "Canteras", email = "mcanteras@gmail.com", role = c("ctb", "cph")),
    person("Bishwa", "Karki", email = "karkeebishwa1@gmail.com", role = c("ctb", "cph")),
    person("Mehul", "Kumar Nirala", email = "mehulkumarnirala@gmail.com", role = c("ctb", "cph")),
    person("Heet", "Sankesara", email = "heetsankesara3@gmail.com", role = c("ctb", "cph")),
    person("Jeffin", "Sam", email = "sam.jeffin@gmail.com", role = c("ctb", "cph")),
    person("Vikas", "S Shetty", email = "shettyvikas209@gmail.com", role = c("ctb", "cph")),
    person("Khizir", "Siddiqui", email = "khizirsiddiqui@gmail.com", role = c("ctb", "cph")),
    person("Tejasvi", "Tomar", email = "tstomar@outlook.com", role = c("ctb", "cph")),
    person("Jai", "Agarwal", email = "jai.bhageria@gmail.com", role = c("ctb", "cph")),
    person("Ziyang", "Jiang", email = "zij004@alumni.stanford.edu", role = c("ctb", "cph")),
    person("Rohit", "Kartik", email = "rohit.audrey@gmail.com", role = c("ctb", "cph")),
    person("Aditya", "Viki", email = "adityaviki01@gmail.com", role = c("ctb", "cph")),
    person("Kartik", "Dutt", email = "kartikdutt@live.in", role = c("ctb", "cph")),
    person("Suryoday", "Basak", email = "suryodaybasak@gmail.com", role = c("ctb", "cph")),
    person("Sriram", "S K", email = "sriramsk1999@gmail.com", role = c("ctb", "cph")),
    person("Manoranjan", "Kumar Bharti ( Nakul Bharti )", email = "knakul853@gmail.com", role = c("ctb", "cph")),
    person("Saraansh", "Tandon", email = "saraanshtandon1999@gmail.com", role = c("ctb", "cph")),
    person("Gaurav", "Singh", email = "gs8763076@gmail.com", role = c("ctb", "cph")),
    person("Lakshya", "Ojha", email = "ojhalakshya@gmail.com", role = c("ctb", "cph")),
    person("Bisakh", "Mondal", email = "bisakhmondal00@gmail.com", role = c("ctb", "cph")),
    person("Benson", "Muite", email = "benson_muite@emailplus.org", role = c("ctb", "cph")),
    person("Sarthak", "Bhardwaj", email = "7sarthakbhardwaj@gmail.com", role = c("ctb", "cph")),
    person("Aakash", "Kaushik", email = "kaushikaakash7539@gmail.com", role = c("ctb", "cph")),
    person("Anush", "Kini", email = "anushkini@gmail.com", role = c("ctb", "cph")),
    person("Nippun", "Sharma", email = "inbox.nippun@gmail.com", role = c("ctb", "cph")),
    person("Rishabh", "Garg", email = "rishabhgarg108@gmail.com", role = c("ctb", "cph")),

=== src/mlpack/tests/CMakeLists.txt ===
include(CTest)

# mlpack test executable.
add_executable(mlpack_test
  ${MLPACK_TEST_SRCS}

  # Tests for neural network code (and reinforcement learning code).
  ann/activation_functions_test.cpp
  ann/ann_dist_test.cpp
  # This includes all files in ann/layer/.
  ann/layer_test.cpp
  ann/ann_regularizer_test.cpp
  ann/ann_test_tools.hpp
  ann/convolutional_network_test.cpp
  ann/convolution_test.cpp
  ann/custom_layer.hpp
  ann/dag_network_test.cpp
  ann/feedforward_network_test.cpp
  ann/fp16_test.cpp
  ann/init_rules_test.cpp
  ann/ksinit_test.cpp
  ann/loss_functions_test.cpp
  ann/recurrent_network_test.cpp

  ann/async_learning_test.cpp
  ann/augmented_rnns_tasks_test.cpp
  ann/reward_clipping_test.cpp
  ann/rl_components_test.cpp
  ann/models/yolov3_tests.cpp

  # These tests have not yet been adapted to the new inheritance-based ANN
  # implementation.
#  ann/not_adapted/activation_functions_test.cpp
#  ann/not_adapted/ann_layer_test.cpp
#  ann/not_adapted/feedforward_network_test.cpp
#  ann/not_adapted/recurrent_network_test.cpp
#  ann/not_adapted/rbm_network_test.cpp
#  ann/not_adapted/rnn_reber_test.cpp
#  ann/not_adapted/dcgan_test.cpp
#  ann/not_adapted/gan_test.cpp
#  ann/not_adapted/wgan_test.cpp

  # Tests for other methods.
  adaboost_test.cpp
  akfn_test.cpp
  aknn_test.cpp
  armadillo_svd_test.cpp
  arma_extend_test.cpp
  bayesian_linear_regression_test.cpp
  bias_svd_test.cpp
  binarize_test.cpp
  block_krylov_svd_test.cpp
  callback_test.cpp
  cf_test.cpp
  cli_binding_test.cpp
  cosine_tree_test.cpp
  cv_test.cpp
  dbscan_test.cpp
  decision_tree_regressor_test.cpp
  decision_tree_test.cpp
  det_test.cpp
  digamma_test.cpp
  distance_test.cpp
  distribution_test.cpp
  drusilla_select_test.cpp
  emst_test.cpp
  facilities_test.cpp
  fastmks_test.cpp
  gmm_test.cpp
  hmm_test.cpp
  hpt_test.cpp
  hoeffding_tree_test.cpp
  hyperplane_test.cpp
  image_test.cpp
  imputation_test.cpp
  io_test.cpp
  kde_model_test.cpp
  kde_test.cpp
  kernel_pca_test.cpp
  kernel_test.cpp
  kernel_traits_test.cpp
  kfn_test.cpp
  kmeans_test.cpp
  knn_test.cpp
  krann_search_test.cpp
  lars_test.cpp
  linear_regression_test.cpp
  lmnn_test.cpp
  linear_svm_test.cpp
  load_save_test.cpp
  local_coordinate_coding_test.cpp
  logistic_regression_test.cpp
  log_test.cpp
  lsh_test.cpp
  main.cpp
  math_test.cpp
  matrix_completion_test.cpp
  maximal_inputs_test.cpp
  metric_test.cpp
  mean_shift_test.cpp
  mock_categorical_data.hpp
  nbc_test.cpp
  nca_test.cpp
  nmf_test.cpp
  nystroem_method_test.cpp
  octree_test.cpp
  one_hot_encoding_test.cpp
  pca_test.cpp
  perceptron_test.cpp
  policy_gradient_test.cpp
  prefixedoutstream_test.cpp
  python_binding_test.cpp
  qdafn_test.cpp
  quic_svd_test.cpp
  q_learning_test.cpp
  radical_test.cpp
  random_forest_test.cpp
  random_test.cpp
  randomized_svd_test.cpp
  range_search_test.cpp
  rectangle_tree_test.cpp
  regularized_svd_test.cpp
  scaling_test.cpp
  size_checks_test.cpp
  serialization.cpp
  serialization.hpp
  serialization_test.cpp
  sfinae_test.cpp
  softmax_regression_test.cpp
  sort_policy_test.cpp
  sparse_autoencoder_test.cpp
  sparse_coding_test.cpp
  spill_tree_test.cpp
  split_data_test.cpp
  string_encoding_test.cpp
  sumtree_test.cpp
  svd_batch_test.cpp
  svd_incremental_test.cpp
  svdplusplus_test.cpp
  termination_policy_test.cpp
  test_catch_tools.hpp
  test_function_tools.hpp
  test_reinforcement_learning_agent.hpp
  timer_test.cpp
  tree_test.cpp
  tree_traits_test.cpp
  trigamma_test.cpp
  ub_tree_test.cpp
  union_find_test.cpp
  vantage_point_tree_test.cpp
  xgboost_test.cpp

  # Tests for individual bindings.
  main_tests/adaboost_test.cpp
  main_tests/adaboost_train_test.cpp
  main_tests/adaboost_classify_test.cpp
  main_tests/adaboost_probabilities_test.cpp
  main_tests/approx_kfn_test.cpp
  main_tests/bayesian_linear_regression_test.cpp
  main_tests/cf_test.cpp
  main_tests/dbscan_test.cpp
  main_tests/decision_tree_test.cpp
  main_tests/det_test.cpp
  main_tests/emst_test.cpp
  main_tests/fastmks_test.cpp
  main_tests/gmm_generate_test.cpp
  main_tests/gmm_probability_test.cpp
  main_tests/gmm_train_test.cpp
  main_tests/hmm_generate_test.cpp
  main_tests/hmm_loglik_test.cpp
  main_tests/hmm_test_utils.hpp
  main_tests/hmm_train_test.cpp
  main_tests/hmm_viterbi_test.cpp
  main_tests/hoeffding_tree_test.cpp
  main_tests/image_converter_test.cpp
  main_tests/kde_test.cpp
  main_tests/kernel_pca_test.cpp
  main_tests/kfn_test.cpp
  main_tests/kmeans_test.cpp
  main_tests/knn_test.cpp
  main_tests/krann_test.cpp
  main_tests/linear_regression_test.cpp
  main_tests/linear_regression_train_test.cpp
  main_tests/linear_regression_predict_test.cpp
  main_tests/linear_svm_test.cpp
  main_tests/lmnn_test.cpp
  main_tests/local_coordinate_coding_test.cpp
  main_tests/logistic_regression_test.cpp
  main_tests/lsh_test.cpp
  main_tests/mean_shift_test.cpp
  main_tests/nbc_test.cpp
  main_tests/nca_test.cpp
  main_tests/nmf_test.cpp
  main_tests/pca_test.cpp
  main_tests/perceptron_test.cpp
  main_tests/preprocess_binarize_test.cpp
  main_tests/preprocess_imputer_test.cpp
  main_tests/preprocess_one_hot_encode_test.cpp
  main_tests/preprocess_scale_test.cpp
  main_tests/preprocess_split_test.cpp
  main_tests/radical_test.cpp
  main_tests/random_forest_test.cpp
  main_tests/range_search_test.cpp
  main_tests/softmax_regression_test.cpp
  main_tests/sparse_coding_test.cpp
  main_tests/main_test_fixture.hpp
)

if(NOT BUILD_SHARED_LIBS)
# Build mlpack test executable statically.
  target_link_libraries(mlpack_test -static
    ${MLPACK_LIBRARIES}
  )
else()
  # Build mlpack test executable dynamically.
  target_link_libraries(mlpack_test
    ${MLPACK_LIBRARIES}
  )
endif()

# If the user asked for running test cases with verbose output, turn that on.
if (TEST_VERBOSE)
  target_compile_definitions(mlpack_test PUBLIC
      -DMLPACK_PRINT_DEBUG -DMLPACK_PRINT_INFO -DMLPACK_PRINT_WARN)
else()
  # Otherwise, suppress all [FATAL] output.
  target_compile_definitions(mlpack_test PUBLIC -DMLPACK_SUPPRESS_FATAL)
endif()

# This has to be added here so that cotire picks it up (even though it is in
# individual tests).
if (CMAKE_VERSION VERSION_GREATER "3.16.0" AND USE_PRECOMPILED_HEADERS)
  if (MSVC)
    # NOTE: this is a workaround for a Github runner issue caused by a bad
    # update.  See https://github.com/actions/runner-images/issues/10004 for
    # more details.  It's likely that this workaround doesn't need to be here
    # for long.
    target_compile_definitions(mlpack_test PUBLIC
        -D_DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR)

    # MSVC RAM usage is decreased significantly if mlpack.hpp is included as a
    # precompiled header.  (It is still pretty slow, but this is necessary to
    # avoid a C1060 on Azure Pipelines.)
    target_compile_definitions(mlpack_test PUBLIC
        -DMLPACK_ENABLE_ANN_SERIALIZATION)
    target_precompile_headers(mlpack_test PUBLIC
        "../core.hpp"
        "../../mlpack.hpp"
        <ensmallen.hpp>
        <armadillo>)
  else ()
    target_precompile_headers(mlpack_test PUBLIC
        "../prereqs.hpp"
        "catch.hpp"
        "test_catch_tools.hpp"
        "serialization.hpp")
    set_source_files_properties(main.cpp PROPERTIES SKIP_PRECOMPILE_HEADERS ON)
  endif ()
endif ()

# Copy test data into right place.
add_custom_command(TARGET mlpack_test
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/data/
      ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/doc/img/cat.jpg
      ${PROJECT_BINARY_DIR}/
)

add_custom_command(TARGET mlpack_test
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E tar xjf mnist_first250_training_4s_and_9s.tar.bz2
  COMMAND ${CMAKE_COMMAND} -E tar xjf lars_kkt.tar.bz2
  COMMAND ${CMAKE_COMMAND} -E tar xjf digits_train.tar.bz2
  COMMAND ${CMAKE_COMMAND} -E tar xjf digits_test.tar.bz2
  COMMAND ${CMAKE_COMMAND} -E tar xjf digits_train_label.tar.bz2
  COMMAND ${CMAKE_COMMAND} -E tar xjf digits_test_label.tar.bz2
  COMMAND ${CMAKE_COMMAND} -E tar xjf sheep.tar.bz2
  WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
)

add_test(NAME "catch_test" COMMAND mlpack_test WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

set_tests_properties("catch_test" PROPERTIES TIMEOUT 0)

=== src/mlpack/bindings/R/CMakeLists.txt ===
macro (not_found_return message)
  message(STATUS "${message}")
  macro (add_r_binding directory name)
    # Do nothing.
  endmacro ()

  macro (post_r_setup)
    # Do nothing.
  endmacro ()

  return()
endmacro ()

# If we are not supposed to make R bindings, define the macro so it does
# nothing and leave this file.
if (NOT BUILD_R_BINDINGS)
  not_found_return("Not building R bindings.")
endif ()

if (BUILD_R_BINDINGS)

  # If mlpack upgrade the version of dependencies, then we also have to update the version here.
  set(RcppArmadillo_Version "0.${ARMADILLO_VERSION}")
  set(RcppEnsmallen_Version "0.${ENSMALLEN_VERSION}")

  # Import find_r_module.
  include(${CMAKE_SOURCE_DIR}/CMake/FindRModule.cmake)
  find_package(R 4.0)
  if (NOT R_FOUND)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - R")
  endif ()
  find_r_module(roxygen2)
  if (NOT R_ROXYGEN2)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - roxygen2")
  endif ()
  find_r_module(Rcpp 0.12.12)
  if (NOT R_RCPP)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - Rcpp")
  endif ()
  find_r_module(RcppArmadillo "${RcppArmadillo_Version}")
  if (NOT R_RCPPARMADILLO)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - RcppArmadillo")
  endif ()
  find_r_module(RcppEnsmallen "${RcppEnsmallen_Version}")
  if (NOT R_RCPPENSMALLEN)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - RcppEnsmallen")
  endif ()
  find_r_module(testthat)
  if (NOT R_TESTTHAT)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - testthat")
  endif ()
  find_r_module(pkgbuild) # Required for roxygen2 with src/ directories.
  if (NOT R_PKGBUILD)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - pkgbuild")
  endif ()

  ## We need to check here if R and other dependencies is even available, as
  ## it is require to build R-bindings.
  if (FORCE_BUILD_R_BINDINGS)
    if (NOT R_FOUND OR NOT R_RCPP OR NOT R_RCPPARMADILLO OR NOT R_RCPPENSMALLEN
        OR NOT R_ROXYGEN2 OR NOT R_TESTTHAT OR NOT R_PKGBUILD)
      unset(BUILD_R_BINDINGS CACHE)
      message(FATAL_ERROR "Could not Build R Bindings, Following modules are not available:${R_NOT_FOUND_MSG}")
    endif()
  else ()
    if (NOT R_FOUND OR NOT R_RCPP OR NOT R_RCPPARMADILLO OR NOT R_RCPPENSMALLEN
        OR NOT R_ROXYGEN2 OR NOT R_TESTTHAT OR NOT R_PKGBUILD)
      unset(BUILD_R_BINDINGS CACHE)
      not_found_return("Not building R bindings, Following modules are not available:${R_NOT_FOUND_MSG}")
    endif()
  endif ()

  add_custom_target(R ALL)

  # Now configure DESCRIPTION.
  file(READ "${CMAKE_SOURCE_DIR}/src/mlpack/core/util/version.hpp"
      VERSION_HPP_CONTENTS)
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MAJOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MAJOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MINOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MINOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_PATCH [\"]?([0-9x]+)[\"]?.*"
      "\\1" MLPACK_VERSION_PATCH "${VERSION_HPP_CONTENTS}")
  set(PACKAGE_VERSION
      "${MLPACK_VERSION_MAJOR}.${MLPACK_VERSION_MINOR}.${MLPACK_VERSION_PATCH}")
  if (USING_GIT)
    set(PACKAGE_DOC_VERSION "git")
  else ()
    set(PACKAGE_DOC_VERSION "${PACKAGE_VERSION}")
  endif ()

  string(TIMESTAMP PACKAGE_DATE "%Y-%m-%d")

  # We need to generate an Authors@R list using every single contributor in
  # COPYRIGHT.txt.  That takes a little bit of processing.
  file(READ "${CMAKE_SOURCE_DIR}/COPYRIGHT.txt" COPYRIGHT_TXT_CONTENTS)
  string(REGEX MATCHALL "  Copyright [0-9-]*, ([^\n]*)\n" CONTRIBUTORS_LIST
      "${COPYRIGHT_TXT_CONTENTS}")

  # These are the authors meant to be listed as 'authors' and not
  # 'contributors'.  If you contributed specifically to the R bindings, you
  # should probably be listed here, so if you're not, open a PR to fix it! :)
  set(SPECIAL_AUTHORS "Yashwant Singh Parihar" "Ryan Curtin" "Dirk Eddelbuettel"
      "James Balamuta")

  string(CONCAT AUTHORS_R "c(\n"
      "    person(\"Yashwant\", \"Singh Parihar\", "
              "email = \"yashwantsingh.sngh@gmail.com\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),\n"
      "    person(\"Ryan\", \"Curtin\", email = \"ryan@ratml.org\", "
              "role = c(\"aut\", \"ctb\", \"cph\", \"cre\")),\n"
      "    person(\"Dirk\", \"Eddelbuettel\", email = \"edd@debian.org\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),\n"
      "    person(\"James\", \"Balamuta\", "
              "email = \"james.balamuta@gmail.com\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),")
  foreach (CONTRIBUTOR_LINE ${CONTRIBUTORS_LIST})
    # Strip 'Copyright XXXX-YYYY, '.
    string(REGEX REPLACE "^  Copyright [0-9-]*, (.*)\n$" "\\1"
        CONTRIBUTOR_FILTERED "${CONTRIBUTOR_LINE}")

    # Extract the email if it exists.
    string(REGEX MATCH "^[^<]*<(.*)>.*$" HAS_EMAIL "${CONTRIBUTOR_FILTERED}")

    # The first name is just the first space-delimited word.  (That may not
    # always be right, but we have no way to know what is a first name and last
    # name and therefore must assume.)
    string(REGEX REPLACE "^([^ ]*) .*$" "\\1" CONTRIBUTOR_FIRST_NAME
        "${CONTRIBUTOR_FILTERED}")

    # Extracting the last name is just the rest of the tokens, but the regex is
    # different depending on whether we managed to get an email.
    if (HAS_EMAIL)
      string(REGEX REPLACE "^[^<]*<(.*)>.*$" "\\1" CONTRIBUTOR_EMAIL
          "${CONTRIBUTOR_FILTERED}")
      string(REGEX MATCH "^[^ ]* (.*) <.*$" CONTRIBUTOR_LAST_NAME
          "${CONTRIBUTOR_FILTERED}")
      if (NOT CONTRIBUTOR_LAST_NAME)
        set (CONTRIBUTOR_LAST_NAME "")
      else ()
        string(REGEX REPLACE "^[^ ]* (.*) <.*$" "\\1" CONTRIBUTOR_LAST_NAME
            "${CONTRIBUTOR_FILTERED}")
      endif ()

      # Skip anyone already listed as an author.
      if ("${CONTRIBUTOR_FIRST_NAME} ${CONTRIBUTOR_LAST_NAME}" IN_LIST
          SPECIAL_AUTHORS)
        continue()
      endif ()

      string(CONCAT AUTHORS_R "${AUTHORS_R}\n    "
          "person(\"${CONTRIBUTOR_FIRST_NAME}\", \"${CONTRIBUTOR_LAST_NAME}\", "
          "email = \"${CONTRIBUTOR_EMAIL}\", role = c(\"ctb\", \"cph\")),")

    else ()
      # No email is available.  So just get the last name.
      string(REGEX MATCH "^[^ ]* (.*)$" CONTRIBUTOR_LAST_NAME
          "${CONTRIBUTOR_FILTERED}")
      if (NOT CONTRIBUTOR_LAST_NAME)
        set (CONTRIBUTOR_LAST_NAME "")
      else ()
        string(REGEX REPLACE "^[^ ]* (.*)$" "\\1" CONTRIBUTOR_LAST_NAME
            "${CONTRIBUTOR_FILTERED}")
      endif ()

      # Skip anyone already listed as an author.
      if ("${CONTRIBUTOR_FIRST_NAME} ${CONTRIBUTOR_LAST_NAME}" IN_LIST
          SPECIAL_AUTHORS)
        continue()
      endif ()

      string(CONCAT AUTHORS_R "${AUTHORS_R}\n    "
          "person(\"${CONTRIBUTOR_FIRST_NAME}\", \"${CONTRIBUTOR_LAST_NAME}\", "
          "role = c(\"ctb\", \"cph\")),")
    endif ()
  endforeach ()
  # We also have to remove the final comma...
  string(REGEX REPLACE ",$" "" AUTHORS_R_OUT "${AUTHORS_R}")
  set(AUTHORS_R "${AUTHORS_R_OUT})")

  configure_file(${CMAKE_SOURCE_DIR}/src/mlpack/bindings/R/mlpack/DESCRIPTION.in
                 ${CMAKE_CURRENT_BINARY_DIR}/mlpack/DESCRIPTION
                 @ONLY)

  # Create the empty NAMESPACE file that will include all export functions.
  file(WRITE
      "${CMAKE_CURRENT_BINARY_DIR}/mlpack/NAMESPACE"
      "# Generated by roxygen2: do not edit by hand"
      "\n\n")

  set(CPP_SOURCES
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/r_util.cpp"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/rcpp_mlpack.h"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/Makevars"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/Makevars.win"
  )

  set(R_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/R/matrix_utils.R"
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/R/package.R"
  )

  set(BINDINGS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/get_type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc_functions.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc_functions_impl.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_input_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_printable_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_r_type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_input_processing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_output_processing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_serialize_util.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack_main.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/R_option.hpp"
  )

  set(TESTS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/tests/test_r_binding_main.cpp"
  )

  set(R_TESTTHAT_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/tests/testthat/test-R_binding.R"
  )

  set(R_TESTS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/tests/testthat.R"
  )

  # Configure the license file.
  string(TIMESTAMP LICENSE_YEAR "%Y")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mlpack/LICENSE.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/mlpack/LICENSE")

  add_custom_target(r_copy ALL)

  # First we have to create all the required directories for copy.
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/R/
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests/testthat
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R/tests
   )

  if (BUILD_TESTS)
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${TESTS_SOURCES}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R/tests)
  endif()

  # Copy all necessary files for building package.
  foreach(cpp_file ${CPP_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${cpp_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/)
  endforeach()
  foreach(r_file ${R_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${r_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/R/)
  endforeach()
  foreach(bindings_file ${BINDINGS_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${bindings_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R)
  endforeach()
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
          ${R_TESTTHAT_SOURCES}
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests/testthat)
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
          ${R_TESTS_SOURCES}
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests)
  # This file will take care of multiple definition of functions in .cpp files.
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E touch
          "${CMAKE_CURRENT_BINARY_DIR}/mlpack/model.txt")

  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/cleanup"
       DESTINATION
       "${CMAKE_CURRENT_BINARY_DIR}/mlpack/")

  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/inst/CITATION"
       DESTINATION
       "${CMAKE_CURRENT_BINARY_DIR}/mlpack/inst")

  # Do the actual build.
  add_custom_target(r_build ALL)

  # "model.txt" is no longer useful, after generating src/.cpp files.
  # Remove this file.
  add_custom_command(TARGET r_build POST_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E remove -f "model.txt"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/mlpack"
  )

  # Build RcppExports.cpp/.R, NAMESPACE and man/ files.
  add_custom_command(TARGET r_build POST_BUILD
      COMMAND ${RSCRIPT_EXECUTABLE} ARGS "-e" "'Rcpp::compileAttributes()'"
      COMMAND ${RSCRIPT_EXECUTABLE} ARGS "-e" "'roxygen2::roxygenize(\".\")'"

=== src/mlpack/bindings/python/CMakeLists.txt ===
macro (not_found_return message)
  message(STATUS "${message}")
  macro (add_python_binding directory name)
    # Do nothing.
  endmacro ()
  macro (add_python_wrapper directory group_name)
    # Do nothing.
  endmacro ()

  return()
endmacro ()

macro (post_python_bindings)
  # If we are building Python bindings, we have to configure setup.py but only
  # after we've recursed into methods/.
  if (BUILDING_PYTHON_BINDINGS)
    get_property(CYTHON_INCLUDE_DIRECTORIES DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        PROPERTY INCLUDE_DIRECTORIES)
    add_custom_target(python_configure
        COMMAND ${CMAKE_COMMAND}
            -D GENERATE_CPP_IN=${CMAKE_SOURCE_DIR}/src/mlpack/bindings/python/setup.py.in
            -D GENERATE_CPP_OUT=${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/setup.py
            -D PACKAGE_VERSION="${PACKAGE_VERSION}"
            -D MLPACK_LIBRARIES="${MLPACK_LIBRARIES}"
            -D MLPACK_PYXS="${MLPACK_PYXS}"
            -D OpenMP_CXX_FLAGS="${OpenMP_CXX_FLAGS}"
            -D DISABLE_CFLAGS="${DISABLE_CFLAGS}"
            -D CYTHON_INCLUDE_DIRECTORIES="${CYTHON_INCLUDE_DIRECTORIES}"
            -D CMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}
            -D EXTRA_CXX_FLAGS="-DMLPACK_PRINT_INFO -DMLPACK_PRINT_WARN"
            -D OUTPUT_DIR=${CMAKE_BINARY_DIR}
            -D CCACHE_PROGRAM=${CCACHE_PROGRAM}
            -D CMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}
            -P "${CMAKE_SOURCE_DIR}/CMake/ConfigureFile.cmake"
        BYPRODUCTS "${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/setup.py"
        COMMENT "Configuring setup.py...")
    add_dependencies(python_configure python_copy)
    add_dependencies(python_configured python_configure)

    # Append the package version to __init__.py after all the imports are loaded.
    file(APPEND ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/__init__.py
    "__version__='${PACKAGE_VERSION}'\n")
  endif ()
endmacro ()

# If we are not supposed to make Python bindings, define the macro so it does
# nothing and leave this file.
if (NOT BUILD_PYTHON_BINDINGS)
  not_found_return("Not building Python bindings.")
endif ()

# Generate Python setuptools file.
# Import find_python_module.
include(${CMAKE_SOURCE_DIR}/CMake/FindPythonModule.cmake)
find_package(PythonInterp)
if (NOT PYTHON_EXECUTABLE)
  set(PY_NOT_FOUND_MSG "${PY_NOT_FOUND_MSG}\n    - Python")
endif()
find_python_module(distutils)
if (NOT PY_DISTUTILS)
  set(PY_NOT_FOUND_MSG "${PY_NOT_FOUND_MSG}\n    - distutils")
endif ()
find_python_module(Cython 0.24)
if (NOT PY_CYTHON)
  set(PY_NOT_FOUND_MSG "${PY_NOT_FOUND_MSG}\n    - Cython")
endif ()
find_python_module(numpy)
if (NOT PY_NUMPY)
  set(PY_NOT_FOUND_MSG "${PY_NOT_FOUND_MSG}\n    - numpy")
endif ()
find_python_module(pandas 0.15.0)
if (NOT PY_PANDAS)
  set(PY_NOT_FOUND_MSG "${PY_NOT_FOUND_MSG}\n    - pandas")
endif ()
find_python_module(wheel)
if (NOT PY_WHEEL)
  set(PY_NOT_FOUND_MSG "${PY_NOT_FOUND_MSG}\n    - wheel")
endif ()

## We need to check here if Python and other dependencies is even available, as
## it is require to build python-bindings.
if (FORCE_BUILD_PYTHON_BINDINGS)
  if (NOT PYTHON_EXECUTABLE OR NOT PY_DISTUTILS OR NOT PY_CYTHON OR NOT PY_NUMPY
      OR NOT PY_PANDAS OR NOT PY_WHEEL)
    unset(BUILD_PYTHON_BINDINGS CACHE)
    message(FATAL_ERROR "\nCould not Build Python Bindings; the following modules are not available: ${PY_NOT_FOUND_MSG}")
  endif()
else()
  if (NOT PYTHON_EXECUTABLE OR NOT PY_DISTUTILS OR NOT PY_CYTHON OR NOT PY_NUMPY
      OR NOT PY_PANDAS OR NOT PY_WHEEL)
    unset(BUILD_PYTHON_BINDINGS CACHE)
    not_found_return("Not building Python bindings; the following modules are not available: ${PY_NOT_FOUND_MSG}")
  endif()
endif()

set(BUILDING_PYTHON_BINDINGS ON PARENT_SCOPE)

# Nothing in this directory will be compiled into mlpack.
# These are all the files we need to compile Cython bindings for mlpack that are
# not a part of mlpack itself.
set(CYTHON_SOURCES
  # mlpack/__init__.py is not included here---that is copied separately.
  mlpack/arma_numpy.pxd
  mlpack/arma_numpy.pyx
  mlpack/arma.pxd
  mlpack/arma_util.hpp
  mlpack/io.pxd
  mlpack/io_util.hpp
  mlpack/matrix_utils.py
  mlpack/serialization.hpp
  mlpack/serialization.pxd
  mlpack/params.pxd
  mlpack/preprocess_json_params.py
  mlpack/timers.pxd
)

set(TEST_SOURCES
  tests/test_dataset_info.py
  tests/test_python_binding.py
)

# Set the include directories correctly.
get_property(CYTHON_INCLUDE_DIRECTORIES DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    PROPERTY INCLUDE_DIRECTORIES)
set (CYTHON_INCLDIRS "${CYTHON_INCLUDE_DIRECTORIES}")

# By default, Python appears to compile with -DNDEBUG, but if we are in debug
# mode we don't want that.  We also want to disable MLPACK_HAS_BFD_DL if it is
# set.
if (DEBUG)
  set(DISABLE_CFLAGS "NDEBUG;MLPACK_HAS_BFD_DL" PARENT_SCOPE)
endif ()

add_custom_target(python ALL DEPENDS python_copy)
add_custom_target(python_copy ALL)
# The python_configure target is added later; this is a dummy target.
add_custom_target(python_configured ALL)

# Copy necessary files after making the mlpack/ directory.
add_custom_command(TARGET python_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/)
foreach(cython_file ${CYTHON_SOURCES})
  add_custom_command(TARGET python_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy
          ${CMAKE_CURRENT_SOURCE_DIR}/${cython_file}
          ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/)
endforeach()
add_custom_command(TARGET python_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} ARGS -E copy
        ${CMAKE_CURRENT_SOURCE_DIR}/setup.cfg
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/
    BYPRODUCTS ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/${cython_file})
add_custom_command(TARGET python_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} ARGS -E copy
        ${CMAKE_CURRENT_SOURCE_DIR}/copy_artifacts.py
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/)
add_custom_command(TARGET python_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} ARGS -E copy
        ${CMAKE_CURRENT_SOURCE_DIR}/setup_readme.md
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/)

# Copy all mlpack headers for inclusion in the package, but remove the bindings/
# and tests/ directories as they should not be included.
add_custom_command(TARGET python_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} ARGS -E copy_directory
        ${CMAKE_SOURCE_DIR}/src/
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/include/)
add_custom_command(TARGET python_copy PRE_BUILD
    COMMAND ${CMAKE_COMMAND} ARGS -E rm -r
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/include/mlpack/bindings/
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/include/mlpack/tests/)

# Generate pkgconfig file for easy use of included headers.
add_custom_target(python_pkgconfig
    COMMAND ${CMAKE_COMMAND}
        -D GENERATE_CPP_IN=${CMAKE_SOURCE_DIR}/src/mlpack/bindings/python/mlpack.pc.in
        -D GENERATE_CPP_OUT=${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/share/pkgconfig/mlpack.pc
        -D PACKAGE_VERSION="${PACKAGE_VERSION}"
        -P "${CMAKE_SOURCE_DIR}/CMake/ConfigureFileOnly.cmake"
        BYPRODUCTS "${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/share/pkgconfig/mlpack.pc"
        COMMENT "Configuring Python mlpack.pc...")
add_dependencies(python_copy python_pkgconfig)

if (BUILD_TESTS)
  foreach(test_file ${TEST_SOURCES})
    add_custom_command(TARGET python_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy
            ${CMAKE_CURRENT_SOURCE_DIR}/${test_file}
            ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/tests/
        BYPRODUCTS ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/tests/${test_file})
  endforeach ()
endif ()

# Install any dependencies via setuptools automatically.
add_custom_command(TARGET python_configured POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E env NO_BUILD=1 ${PYTHON_EXECUTABLE}
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/setup.py build
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/)

# Then do the actual build.
add_custom_command(TARGET python POST_BUILD
    COMMAND ${PYTHON_EXECUTABLE}
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/setup.py build_ext
    DEPENDS mlpack/arma_numpy.pxd
            mlpack/arma_numpy.pyx
            mlpack/arma.pxd
            mlpack/arma_util.hpp
            mlpack/io.pxd
            mlpack/io_util.hpp
            mlpack/matrix_utils.py
            mlpack/preprocess_json_params.py
            mlpack
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/)

# Copy the built artifacts, so that it is also an in-place build.
add_custom_command(TARGET python POST_BUILD
    COMMAND ${PYTHON_EXECUTABLE}
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/copy_artifacts.py
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/)

add_dependencies(python python_configured)

# Configure installation script file.
if (NOT PYTHON_INSTALL_PREFIX)
  set(PYTHON_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif ()

execute_process(COMMAND ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/print_python_version.py"
    "${PYTHON_INSTALL_PREFIX}"
    OUTPUT_VARIABLE CMAKE_PYTHON_PATH)
string(STRIP "${CMAKE_PYTHON_PATH}" CMAKE_PYTHON_PATH)
if (DEFINED ENV{PYTHONPATH})
  string(APPEND CMAKE_PYTHON_PATH : $ENV{PYTHONPATH})
endif ()
install(CODE "set(ENV{PYTHONPATH} ${CMAKE_PYTHON_PATH})")
install(CODE "set(PYTHON_EXECUTABLE \"${PYTHON_EXECUTABLE}\")")
install(CODE "set(CMAKE_BINARY_DIR \"${CMAKE_BINARY_DIR}\")")

install(CODE "set(PYTHON_INSTALL_PREFIX \"${PYTHON_INSTALL_PREFIX}\")")
install(CODE "execute_process(COMMAND mkdir -p $ENV{DESTDIR}${CMAKE_PYTHON_PATH})")
install(SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/PythonInstall.cmake")

# Prepare __init__.py for having all of the convenience imports appended to it.
file(COPY mlpack/__init__.py DESTINATION
    ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/)

if (WIN32)
  # Copy all necessary DLLs to the Python build directory.
  foreach (dir ${DLL_COPY_DIRS})
    file(GLOB dll_dir_files "${dir}/*.dll")
    file(COPY ${dll_dir_files} DESTINATION ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/)
  endforeach ()

  foreach (dll ${DLL_COPY_LIBS})
    file(COPY ${dll} DESTINATION ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/mlpack/)
  endforeach ()
endif ()

# Add a macro to build a python binding.
macro (add_python_binding directory name)
  if (BUILD_PYTHON_BINDINGS)
    set (MLPACK_PYXS ${MLPACK_PYXS} "${name}.pyx")
    set (MLPACK_PYXS ${MLPACK_PYXS} PARENT_SCOPE)
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/generate_pyx_${name}.cpp
        COMMAND ${CMAKE_COMMAND}
            -DGENERATE_CPP_IN=${CMAKE_SOURCE_DIR}/src/mlpack/bindings/python/generate_pyx.cpp.in
            -DGENERATE_CPP_OUT=${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/generate_pyx_${name}.cpp
            -DPROGRAM_MAIN_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${name}_main.cpp
            -DPROGRAM_NAME=${name}
            -P ${CMAKE_SOURCE_DIR}/CMake/ConfigureFile.cmake
        DEPENDS ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/python/generate_pyx.cpp.in
                ${CMAKE_SOURCE_DIR}/CMake/ConfigureFile.cmake)

    add_executable(generate_pyx_${name}
        ${CMAKE_BINARY_DIR}/src/mlpack/bindings/python/generate_pyx_${name}.cpp
        ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/python/print_pyx.hpp
        ${CMAKE_SOURCE_DIR}/src/mlpack/bindings/python/print_pyx.cpp)
    if (BUILD_SHARED_LIBS)
      target_link_libraries(generate_pyx_${name} ${MLPACK_LIBRARIES})
    else ()
      target_link_libraries(generate_pyx_${name} -static ${MLPACK_LIBRARIES})
    endif ()
    set_target_properties(generate_pyx_${name} PROPERTIES COMPILE_FLAGS
        -DBINDING_TYPE=BINDING_TYPE_PYX)
    add_custom_command(TARGET generate_pyx_${name} POST_BUILD

=== debian/changelog ===
mlpack (4.7.0-1) unstable; urgency=medium

  * Bump policy and update scripts
  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 02 Feb 2026 21:52:15 +0000

=== debian/control ===
Source: mlpack
Section: libs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: cmake, debhelper-compat (= 13),
		python3-numpy-dev,
		pkgconf,
		libcereal-dev,
		libarmadillo-dev,
		libensmallen-dev (>= 2.10.0),
		libstb-dev,
		dh-python, dh-sequence-python3,
		python3, python3-dev, python3-pandas, python3-numpy, cython3, python3-setuptools,
		python3-pytest-runner, python3-pip,
		txt2man,
Standards-Version: 4.7.3
Homepage: https://www.mlpack.org/
Vcs-Git: https://salsa.debian.org/science-team/mlpack.git
Vcs-Browser: https://salsa.debian.org/science-team/mlpack

Package: libmlpack-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
	 libensmallen-dev (>= 2.10.0),
	 libarmadillo-dev, liblapack-dev,
	 libcereal-dev
Recommends: libstb-dev
Suggests: mlpack-doc
Description: intuitive, fast, scalable C++ machine learning library (development libs)
 This package contains the mlpack Library development files.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: python3-mlpack
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends},
	 ${python3:Depends}
Description: intuitive, fast, scalable C++ machine learning library (Python bindings)
 This package contains Python bindings for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: mlpack-bin
Section: science
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: intuitive, fast, scalable C++ machine learning library (binaries)
 This package contains example binaries using the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a “swiss army knife” for machine learning
 researchers.

Package: mlpack-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libjs-jquery
Description: intuitive, fast, scalable C++ machine learning library (documentation)
 This package contains documentation for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a “swiss army knife” for machine learning
 researchers.

=== debian/watch ===
Version: 5

Source: https://www.mlpack.org/files/
